
	LIST P=PIC16F84

        INCLUDE "P16F84.INC"

        __FUSES _XT_OSC & _WDT_ON


OZY1           equ       0Ch
OZY2           equ       0Dh
OZY3           equ       0Eh
OZY4           equ       0Fh
OZY5           equ       10h
OZY6           equ       11h
OZY7           equ       12h
OZY8           equ       13h
OZY9           equ       14h
OZY10          equ       15h
OZY11          equ       16h
OZY12          equ       17h
OZY13          equ       18h
OZY14          equ       19h
OZY15          equ       1Ah
OZY16          equ       1Bh
OZY17          equ       1Ch
OZY18          equ       1Dh
OZY19          equ       1Eh
OZY20          equ       1Fh
OZY21          equ       20h
OZY22          equ       21h
OZY23          equ       22h
OZY24          equ       23h
OZY25          equ       24h
OZY26          equ       25h
OZY27          equ       26h
OZY28          equ       27h
OZY29          equ       28h
OZY30          equ       29h
OZY31          equ       2Ah
OZY32          equ       2Bh
OZY33          equ       2Ch
OZY34          equ       2Dh
OZY35          equ       2Eh
OZY36          equ       2Fh
OZY37		EQU	30H
OZY38		EQU	31H
OZY39		EQU	32H
OZY40		EQU	33H
OZY41		EQU	34H
OZY42		EQU	35H
OZY43		EQU	36H
OZY44		EQU	37H
OZY45		EQU	38H
OZY46		EQU	39H
OZY47		EQU	3AH
OZY48		EQU	3BH
OZY49		EQU	3CH
OZY50		EQU	3DH
OZY51		EQU	3EH
OZY52		EQU	3FH
OZY53		EQU	40H
OZY54		EQU	41H
OZY55		EQU	42H
OZY56		EQU	43H
OZY57		EQU	44H
OZY58		EQU	45H
OZY59		EQU	46H
OZY60		EQU	47H
OZY61		EQU	48H
OZY62		EQU	49H
OZY63		EQU	4AH
OZY64		EQU	4BH
OZY65		EQU	4CH
OZY66		EQU	4DH
OZY67		EQU	4EH
OZY68		EQU	4FH


; LCD Module commands
; ===================
A		EQU		41H
BE		EQU		42H
CE		EQU		43H
D		EQU		44H
E		EQU		45H
FE		EQU		46H
G		EQU		47H
H		EQU		48H
I		EQU		49H
J		EQU		4AH
K		EQU		4BH
L		EQU		4CH
M		EQU		4DH
N		EQU		4EH
O		EQU		4FH
P		EQU		50H
Q		EQU		51H
R		EQU		52H
S		EQU		53H
T		EQU		54H
U		EQU		55H
V		EQU		56H
WE		EQU		57H
X		EQU		58H
Y		EQU		59H
ZE		EQU		5AH
a		equ		61H
be		equ		62H
ce		equ		63H
d		equ		64H
e		equ		65H
f		equ		66H
g		equ		67H
h		equ		68H
i		equ		69H
j		equ		6AH
k		equ		6BH
l		equ		6CH
m		equ		6DH
n		equ		6EH
o		equ		6FH
p		equ		70H
q		equ		71H
r		equ		72H
s		equ		73H
t		equ		74H
u		equ		75H
v		equ		76H
w		equ		77H
x		equ		78H
y		equ		79H
ze		equ		7AH
PB		EQU		80H
;!		equ		21h
GE		EQU		12H
II		EQU		10H
EL		EQU		11H
MZ		EQU		13H
CH		EQU		14H
PE		EQU		15H

          	ORG 0
		GOTO		START

HEL		ADDWF		PCL,1
		RETLW		PB
		RETLW		PB
		RETLW		H	;0
		RETLW		e	;1
		RETLW		l	;2
		RETLW		l	;3
		RETLW		o	;4
		RETLW		PB	;5
		RETLW		be	;6
		RETLW		o	;7
		RETLW		s	;8
		RETLW		s	;9
		RETLW		21H	;10
		RETLW		21H	;11
		RETLW		PB	;12
		RETLW		PB	;13
		RETLW		PB	;14
		RETLW		F	;15
		RETLW		r	;16
		RETLW		3dh	;17


CIFRA		ADDWF		PCL,1
		RETLW		30H	;0
		RETLW		31H	;1
		RETLW		32H	;2
		RETLW		33H	;3
		RETLW		34H	;4
		RETLW		35H	;5
		RETLW		36H	;6
		RETLW		37H	;7
		RETLW		38H	;8
		RETLW		39H	;9
		RETLW		M	;
		RETLW		H	;
		RETLW		ze	;
		RETLW		PB	;
		RETLW		PB	;
		RETLW		PB	;
		RETLW		PB	;

		
SDVIG		ADDWF		PCL,1
		RETLW		D'0'
		RETLW		D'1'
		RETLW		D'2'
		RETLW		D'3'
		RETLW		D'4'
		RETLW		D'8'
		RETLW		D'9'
		RETLW		D'10'
		RETLW		D'11'
		RETLW		D'12'
		RETLW		D'13'
		RETLW		D'14'
		RETLW		D'15'
		RETLW		D'16'


;***********************************************************************;
;   7						;
;***********************************************************************;
ZAD5		CLRWDT							;
		NOP							;
		NOP							;
		NOP							;
		NOP							;
		NOP							;
		NOP							;
		RETURN							;
;***********************************************************************;

;***********************************************************************;
;   15						;
;***********************************************************************;
ZAD15		MOVLW		D'10'					;
		MOVWF		OZY41					;
		CLRF		OZY42					;
Z15		CLRWDT							;
		DECFSZ		OZY42,1					;
		GOTO		Z15					;
		DECFSZ		OZY41,1					;
		GOTO		Z15					;
		RETURN							;
;***********************************************************************;

;***********************************************************************;
;   100					;
;***********************************************************************;
									;
ZAD100		CLRWDT							;
		MOVLW		D'100'					;
		MOVWF		OZY41					;
Z100		CLRWDT							;
		DECFSZ		OZY41,1					;
		GOTO		Z100					;
		RETURN							;
;***********************************************************************;

;***********************************************************************;
; 							;
;***********************************************************************;
ZAGR		CLRWDT							;
		MOVWF		OZY40					;
		ANDLW		B'11110000'
		IORLW		B'00001000'				;
		MOVWF		PORTB					;
		BSF		PORTA,1		; =1		;
		CLRWDT
		CLRWDT
		CLRWDT
		CLRWDT
		CLRWDT
		CLRWDT				; 		;
		BCF		PORTA,1					;
		SWAPF		OZY40,0					;
		ANDLW		B'11110000'
		IORLW		B'00001000'				;
		MOVWF		PORTB					;
		BSF		PORTA,1		; =1		;
		CLRWDT
		CLRWDT
		CLRWDT
		CLRWDT
		CLRWDT
		CLRWDT				; 		;
		BCF		PORTA,1					;
		CALL		ZAD100
		CALL		ZAD100					;
		RETURN							;
;***********************************************************************:
ZAD20		CALL		ZAD05
		CALL		ZAD05
		CALL		ZAD05
		CALL		ZAD05
		CALL		ZAD05
		CALL		ZAD05
		CALL		ZAD05
		RETURN
;***********************************************************************;									;
ZAD05		CALL		ZAD15					;
		CALL		ZAD15					;
		CALL		ZAD15
		CALL		ZAD15
		CALL		ZAD15
		CALL		ZAD15
		CALL		ZAD15					;
		RETURN							;
;***********************************************************************;

START     	BSF       	STATUS,RP0
          	MOVLW     	B'10000'
          	MOVWF     	PORTA
          	MOVLW     	B'00000111'
          	MOVWF     	PORTB
          	MOVLW     	B'01011111'
          	MOVWF     	TMR0
          	BCF       	STATUS,RP0

		CLRF		PORTB
		CLRF		PORTA
		CALL		ZAD15
		CALL		ZAD05
		CLRF		OZY1
		CLRF		OZY2
		CLRF		OZY66
		CLRF		OZY67
		CLRF		OZY68
		CLRF		OZY60
		CLRF		OZY61


		CALL		ZAD20
STARTON		CLRWDT
		BTFSC		PORTA,4
		GOTO		STARTON
		CALL		ZAD05
		CALL		ZAD05
		BTFSC		PORTA,4
		GOTO		STARTON
		CALL		ZAD100
		BSF		PORTB,3
		CALL		ALF
        	CALL	      	ZAD15
		BCF		PORTA,0		;RS=0
		MOVLW		30H
		CALL		ZAGR
		CALL		ZAD15
		MOVLW		30H
		CALL		ZAGR
		CALL		ZAD15
		MOVLW		30H
		CALL		ZAGR
		MOVLW		20H
		CALL		ZAGR
		MOVLW		20H
		CALL		ZAGR
		MOVLW		B'00000001'
		CALL		ZAGR
		MOVLW		B'00000010'
		CALL		ZAGR
		MOVLW		06H
		CALL		ZAGR					;
		MOVLW		B'00001100'
		CALL		ZAGR					;					;
		CALL		ZAD05					;
		MOVLW		28H
		CALL		ZAGR
		MOVLW		28H
		CALL		ZAGR
PPP		MOVLW		D'60'
		MOVWF		EEADR
		CALL		TTT
		MOVF		EEDATA,0
		MOVWF		OZY68
		MOVLW		D'200'
		ADDWF		OZY68,0
		BTFSC		STATUS,C
		CALL		OBSBR
		MOVF		OZY68,0
		MOVWF		EEADR
		CALL		TTT
		MOVF		EEDATA,0
		MOVWF		OZY66
		MOVF		OZY68,0
		ADDLW		D'16'
		MOVWF		EEADR
		CALL		TTT
		MOVF		EEDATA,0
		MOVWF		OZY67
		CALL		PROG
GIND		CALL		PIS1
		CALL		PRIVET
		CALL		ZAD20
		CALL		ZAD20
		CALL		IND
		GOTO		OPROS

TTT		CLRWDT
		BSF		STATUS,RP0
		BSF		EEDATA,RD
		BCF		STATUS,RP0
		RETURN

OBSBR		CLRF		OZY34
OBSB		MOVF		OZY34,0
		MOVWF		EEADR
		CLRF		EEDATA
		CALL		ZAPIS
		MOVF		OZY34,0
		ADDLW		D'16'
		MOVWF		EEADR
		MOVLW		D'40'
		MOVWF		EEDATA
		CALL		ZAPIS
		INCF		OZY34,1
		MOVLW		D'10'
		XORWF		OZY34,0
		BTFSS		STATUS,Z
		GOTO		OBSB
		MOVLW		D'60'
		MOVWF		EEADR
		CLRF		EEDATA
		CALL		ZAPIS
		CLRF		OZY68
		RETURN

ZAPIS		CLRWDT
		BSF		STATUS,RP0
		BCF		INTCON,GIE
		BSF		EEDATA,WREN
		MOVLW		055H
		MOVWF		EEADR
		MOVLW		00AAH
		MOVWF		EEADR
		BSF		EEDATA,WR
		BCF		STATUS,RP0
		CALL		ZAD15
		CALL		ZAD15
		RETURN

PRIVET		CLRWDT
		BCF		PORTA,0
		MOVLW		B'10000000'
		CALL		ZAGR
		BSF		PORTA,0
		MOVLW		D'0'
		MOVWF		OZY1
DES		MOVF		OZY1,0
		CALL		HEL
		CALL		ZAGR
		INCF		OZY1,1
		MOVLW		D'16'
		XORWF		OZY1,0
		BTFSS		STATUS,Z
		GOTO		DES
		RETURN


OPROS		CLRWDT
		BTFSS		PORTB,0
		CALL		MEN
		BTFSS		PORTB,1
		CALL		BOL
		BTFSS		PORTB,2
		CALL		FUNC
		BTFSS		PORTA,4
		GOTO		OFFSAT
		CALL		PR_STR
		BTFSC		OZY60,0
		CALL		SIGNAL
		BTFSS		OZY60,0
		CALL		AFC
		CLRF		OZY39
		GOTO		OPROS

OFFSAT		CLRWDT
		CALL		ZAD05
		CALL		ZAD05
		BTFSC		PORTA,4
		GOTO		OPROS
		BCF		PORTA,0
		MOVLW		B'10000000'
		CALL		ZAGR
		BSF		PORTA,0
		MOVLW		D'5'
		MOVWF		OZY38
QRTP		MOVLW		PB
		CALL		ZAGR
		DECFSZ		OZY38,1
		GOTO		QRTP
		MOVLW		P
		CALL		ZAGR
		MOVLW		O
		CALL		ZAGR
		MOVLW		WE
		CALL		ZAGR
		MOVLW		E
		CALL		ZAGR
		MOVLW		R
		CALL		ZAGR
		MOVLW		D'6'
		MOVWF		OZY38
QRTO		MOVLW		PB
		CALL		ZAGR
		DECFSZ		OZY38,1
		GOTO		QRTO
		BCF		PORTA,0
		MOVLW		B'10101000'
		CALL		ZAGR
		BSF		PORTA,0
		MOVLW		D'6'
		MOVWF		OZY38
ASWQ		MOVLW		PB
		CALL		ZAGR
		DECFSZ		OZY38,1
		GOTO		ASWQ
		MOVLW		O
		CALL		ZAGR
		MOVLW		FE
		CALL		ZAGR
		MOVLW		FE
		CALL		ZAGR
		MOVLW		D'7'
		MOVWF		OZY38
ASWE		MOVLW		PB
		CALL		ZAGR
		DECFSZ		OZY38,1
		GOTO		ASWE
		CALL		ZAD20
		CALL		ZAD20
		CALL		ZAD20
		BCF		PORTB,3
		CALL		ALF
		CALL		ZAD100
		GOTO		START

AFC		BTFSS		OZY60,1
		GOTO		SIG
		BTFSS		OZY60,4
		CALL		YES_AFC
		BSF		OZY60,4
		BCF		OZY60,3
		BSF		STATUS,RP0
		MOVLW		B'00110111'
		MOVWF		PORTB
		BCF		STATUS,RP0
		BTFSC		PORTB,4
		CALL		AFCM
		BTFSC		PORTB,5
		CALL		AFCB
		BSF		STATUS,RP0
		MOVLW		B'00000111'
		MOVWF		PORTB
		BCF		STATUS,RP0
		RETURN

YES_AFC		CLRWDT
		BCF		PORTA,0
		MOVLW		B'10000000'
		CALL		ZAGR
		BSF		PORTA,0
		MOVLW		PB
		CALL		ZAGR
		MOVLW		A
		CALL		ZAGR
		MOVLW		u
		CALL		ZAGR
		MOVLW		t
		CALL		ZAGR
		MOVLW		o
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		FE
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		ce
		CALL		ZAGR
		MOVLW		o
		CALL		ZAGR
		MOVLW		n
		CALL		ZAGR
		MOVLW		t
		CALL		ZAGR
		MOVLW		r
		CALL		ZAGR
		MOVLW		o
		CALL		ZAGR
		MOVLW		l
		CALL		ZAGR
		MOVLW		2EH
		CALL		ZAGR
		RETURN
		



AFCM		MOVLW		D'40'
		XORWF		OZY67,0
		BTFSC		STATUS,Z
		RETURN
		CLRW
		XORWF		OZY66,0
		BTFSC		STATUS,Z
		GOTO		AFM
		DECF		OZY66,1
		GOTO		AFCM1
AFM		DECF		OZY67,1
		DECF		OZY66,1
AFCM1		CALL		PROG
		RETURN

AFCB		MOVLW		D'75'
		XORWF		OZY67,0
		BTFSC		STATUS,Z
		RETURN
		INCFSZ		OZY66,1
		GOTO		AFCB1
		INCF		OZY67,1
AFCB1		CALL		PROG
		RETURN



MEN		CLRWDT
		CALL		PIS1
		BTFSS		OZY60,0
		GOTO		MECH
		MOVLW		D'40'
		XORWF		OZY67,0
		BTFSC		STATUS,Z
		GOTO		M_GRAN
		CLRW
		XORWF		OZY66,0
		BTFSC		STATUS,Z
		GOTO		ME1
		DECF		OZY66,1
		GOTO		MEN1
ME1		DECF		OZY67,1
		DECF		OZY66,1
MEN1		CALL		PROG
		CALL		SHKALA
		CLRF		OZY62
MEN2		CLRWDT
		CALL		ZAD100
		BTFSC		PORTB,0
		RETURN
		DECFSZ		OZY62,1
		GOTO		MEN2
		CALL		PIS2
		BSF		OZY39,0
M_SCAN		MOVLW		D'40'
		XORWF		OZY67,0
		BTFSC		STATUS,Z
		GOTO		M_GRN_SCAN
		CLRW
		XORWF		OZY66,0
		BTFSC		STATUS,Z
		GOTO		MG1
		DECF		OZY66,1
		GOTO		MGT
MG1		DECF		OZY67,1
		DECF		OZY66,1
MGT		CALL		PROG
		CALL		SHKALA
		BTFSS		PORTB,1
		GOTO		ALF1
		BTFSS		PORTB,2
		GOTO		ALF1
		BTFSS		PORTB,0
		GOTO		UD_MEN
UDM		BTFSS		PORTB,0
		GOTO		ALF1
		CLRF		OZY39
		CALL		PR_STR
		BTFSS		OZY60,1
		GOTO		M_SCAN
		BCF		OZY48,1
		CALL		ST_SC
		BTFSS		OZY48,1
		GOTO		M_SCAN
		CALL		AFCB
		CALL		AFCB
		CALL		AFCB
		CALL		AFCB
		CALL		AFCB
		RETURN

UD_MEN		BTFSS		OZY39,0
		GOTO		UDM
		CALL		PR_STR
		CALL		SIGNAL
		GOTO		M_SCAN


M_GRAN		MOVLW		D'80'
		MOVWF		OZY67
		CLRF		OZY66
		GOTO		MEN1

M_GRN_SCAN	MOVLW		D'80'
		MOVWF		OZY67
		CLRF		OZY66
		GOTO		MGT

MECH		CLRW
		XORWF		OZY68,0
		BTFSC		STATUS,Z
		GOTO		MCH
		DECF		OZY68,1
MCH1		CALL		IND
		MOVF		OZY68,0
		MOVWF		EEADR
		CALL		TTT
		MOVF		EEDATA,0
		MOVWF		OZY66
		MOVF		OZY68,0
		ADDLW		D'16'
		MOVWF		EEADR
		CALL		TTT
		MOVF		EEDATA,0
		MOVWF		OZY67
		CALL		PROG
		MOVF		OZY68,0
		MOVWF		EEDATA
		MOVLW		D'60'
		MOVWF		EEADR
		CALL		ZAPIS
		CALL		ALF
		RETURN

MCH		MOVLW		D'8'
		MOVWF		OZY68
		GOTO		MCH1

BOL		CLRWDT
		CALL		PIS1
		BTFSS		OZY60,0
		GOTO		BECH
		MOVLW		D'80'
		XORWF		OZY67,0
		BTFSC		STATUS,Z
		GOTO		B_GRAN
		INCFSZ		OZY66,1
		GOTO		BOL1
		INCF		OZY67,1
BOL1		CALL		PROG
		CALL		SHKALA
		CLRF		OZY62
BOL2		CLRWDT
		CALL		ZAD100
		BTFSC		PORTB,1
		RETURN
		INCFSZ		OZY62,1
		GOTO		BOL2
		CALL		PIS2
		BSF		OZY39,0
B_SCAN		MOVLW		D'80'
		XORWF		OZY67,0
		BTFSC		STATUS,Z
		GOTO		B_GRN_SCAN
		INCFSZ		OZY66,1
		GOTO		BGT
		INCF		OZY67,1
BGT		CALL		PROG
		CALL		SHKALA
		BTFSS		PORTB,0
		GOTO		ALF1
		BTFSS		PORTB,2
		GOTO		ALF1
		BTFSS		PORTB,1
		GOTO		UD_BOL
UDB		BTFSS		PORTB,1
		GOTO		ALF1
		CLRF		OZY39
		CALL		PR_STR
		BTFSS		OZY60,1
		GOTO		B_SCAN
		BCF		OZY48,0
		CALL		ST_SC
		BTFSS		OZY48,0
		GOTO		B_SCAN
		CALL		AFCM
		CALL		AFCM
		CALL		AFCM
		CALL		AFCM
		CALL		AFCM
		RETURN

UD_BOL		BTFSS		OZY39,0
		GOTO		UDB
		CALL		PR_STR
		CALL		SIGNAL
		GOTO		B_SCAN

B_GRAN		MOVLW		D'40'
		MOVWF		OZY67
		CLRF		OZY66
		GOTO		BOL1

B_GRN_SCAN	MOVLW		D'40'
		MOVWF		OZY67
		CLRF		OZY66
		GOTO		BGT

BECH		MOVLW		D'8'
		XORWF		OZY68,0
		BTFSC		STATUS,Z
		GOTO		BCH
		INCF		OZY68,1
BCH1		CALL		IND
		MOVF		OZY68,0
		MOVWF		EEADR
		CALL		TTT
		MOVF		EEDATA,0
		MOVWF		OZY66
		MOVF		OZY68,0
		ADDLW		D'16'
		MOVWF		EEADR
		CALL		TTT
		MOVF		EEDATA,0
		MOVWF		OZY67
		CALL		PROG
		MOVF		OZY68,0
		MOVWF		EEDATA
		MOVLW		D'60'
		MOVWF		EEADR
		CALL		ZAPIS
		CALL		ALF
		RETURN

BCH		CLRF		OZY68
		GOTO		BCH1

;OZY60
;0-0-  
;0-1- 
;1-0- 
;1-1- 
;

ST_SC		BSF		STATUS,RP0
		MOVLW		B'00110111'
		MOVWF		PORTB
		BCF		STATUS,RP0
		BTFSC		PORTB,4
		BSF		OZY48,0
		BTFSC		PORTB,5
		BSF		OZY48,1
		BSF		STATUS,RP0
		MOVLW		B'00000111'
		MOVWF		PORTB
		BCF		STATUS,RP0
		RETURN


FUNC		CLRWDT
		CALL		PIS2
		BTFSC		OZY60,0
		GOTO		FUNC1
		BSF		OZY60,0
		CALL		PR_STR
		CALL		SIGNAL
		CALL		SHKALA
		CALL		ALF
		RETURN

FUNC1		BCF		OZY60,0
		CALL		IND
		CALL		ALF3
		CALL		ALF
		RETURN


SIGNAL		BTFSS		OZY60,1
		GOTO		SIG
		BTFSS		OZY60,2
		CALL		CONNECT
		BSF		OZY60,2
		BCF		OZY60,3
		BCF		OZY60,4
		RETURN

SIG		BTFSS		OZY60,3
		CALL		NO_SIG
		BSF		OZY60,3
		BCF		OZY60,2
		BCF		OZY60,4
		RETURN

CONNECT		BCF		PORTA,0
		MOVLW		B'10000000'
		CALL		ZAGR
		BSF		PORTA,0
		MOVLW		PB
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		FE
		CALL		ZAGR
		MOVLW		M
		CALL		ZAGR
		MOVLW		PB
CONN		CALL		ZAGR
		MOVLW		s
		CALL		ZAGR
		MOVLW		i
		CALL		ZAGR
		MOVLW		g
		CALL		ZAGR
		MOVLW		n
		CALL		ZAGR
		MOVLW		a
		CALL		ZAGR
		MOVLW		l
		CALL		ZAGR
		MOVLW		2EH
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		CALL		ZAD5
		CALL		ZAD5
		RETURN

NO_SIG		BCF		PORTA,0
		MOVLW		B'10000000'
		CALL		ZAGR
		BSF		PORTA,0
		MOVLW		PB
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		N
		CALL		ZAGR
		MOVLW		o
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		s
		CALL		ZAGR
		MOVLW		i
		CALL		ZAGR
		MOVLW		g
		CALL		ZAGR
		MOVLW		n
		CALL		ZAGR
		MOVLW		a
		CALL		ZAGR
		MOVLW		l
		CALL		ZAGR
		MOVLW		2EH
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		RETURN



ALF1		CALL		PIS1
		CALL		ALF3
		CALL		ALF
		RETURN

ALF3		MOVF		OZY68,0
		MOVWF		EEADR
		MOVF		OZY66,0
		MOVWF		EEDATA
		CALL		ZAPIS
		MOVF		OZY68,0
		ADDLW		D'16'
		MOVWF		EEADR
		MOVF		OZY67,0
		MOVWF		EEDATA
		CALL		ZAPIS
		RETURN


ALF		CALL		ZAD100
		BTFSS		PORTB,0
		GOTO		ALF
		BTFSS		PORTB,1
		GOTO		ALF
		BTFSS		PORTB,2
		GOTO		ALF
		BTFSS		PORTA,4
		GOTO		ALF
		RETURN

;PORTA,0 - RS LCD	;DATA
;PORTA,1 - E LCD
;PORTA,2 - CLOK
;PORTA,3 - BEEP
;PORTA,4 - ON/OFF
;PORTB,0 - KN1 <
;PORTB,1 - KN2 >
;PORTB,2 - KN3 F
;PORTB,3 -   
;PORTB,4 - DB4;
;PORTB,5 - DB5;
;PORTB,6 - DB6
;PORTB,7 - DB7;SIGNAL


PIS1		MOVLW		D'70'
		MOVWF		OZY10
		MOVLW		D'150'
		MOVWF		OZY11
		CALL		PIS
		RETURN

PIS2		MOVLW		D'100'
		MOVWF		OZY10
		MOVLW		D'150'
		MOVWF		OZY11
		CALL		PIS
		RETURN


PIS		MOVF		OZY10,0
		MOVWF		OZY12
		BSF		PORTA,3
PI0		DECFSZ		OZY12,1
		GOTO		PI0
		MOVF		OZY10,0
		MOVWF		OZY12
		BCF		PORTA,3
PI1		DECFSZ		OZY12,1
		GOTO		PI1
		DECFSZ		OZY11,1
		GOTO		PIS
		RETURN
		
IND		MOVLW		B'00001111'
		ANDWF		OZY68,1
		MOVF		OZY68,0
		ADDLW		D'1'
		CALL		CIFRA
		MOVWF		OZY65
		BCF		PORTA,0
		MOVLW		B'10101000'
		CALL		ZAGR
		BSF		PORTA,0
		MOVLW		D'4'
		MOVWF		OZY64
IN1		MOVLW		PB
		CALL		ZAGR
		DECFSZ		OZY64,1
		GOTO		IN1
		MOVLW		CE
		CALL		ZAGR
		MOVLW		h
		CALL		ZAGR
		MOVLW		a
		CALL		ZAGR
		MOVLW		n
		CALL		ZAGR
		MOVLW		n
		CALL		ZAGR
		MOVLW		e
		CALL		ZAGR
		MOVLW		l
		CALL		ZAGR
		MOVLW		2DH
		CALL		ZAGR
		MOVF		OZY65,0
		CALL		ZAGR
		MOVLW		D'4'
		MOVWF		OZY64
IN2		MOVLW		PB
		CALL		ZAGR
		DECFSZ		OZY64,1
		GOTO		IN2
		RETURN

SHKALA      	CLRWDT
		MOVF		OZY67,0
		MOVWF		OZY12
         	MOVF        	OZY66,0
         	MOVWF       	OZY11
		MOVLW		D'15'
		SUBWF		OZY12,1
		BCF		STATUS,C
		RRF		OZY12,1
		RRF		OZY11,1
		BCF		STATUS,C
		RRF		OZY12,1
		RRF		OZY11,1
		BCF		STATUS,C
		RRF		OZY12,1
		RRF		OZY11,1
         	CLRF        	OZY21
         	CLRF        	OZY22
         	MOVLW       	D'16'
         	MOVWF       	OZY13
PROV     	CLRWDT
         	MOVLW       	B'00001111'
         	ANDWF       	OZY21,0
         	CALL        	SDVIG
         	MOVWF       	OZY14
         	MOVLW       	B'11110000'
         	ANDWF       	OZY21,1
         	SWAPF       	OZY21,0
         	CALL        	SDVIG
         	MOVWF       	OZY21
         	SWAPF       	OZY21,1
         	MOVF        	OZY14,0
         	IORWF       	OZY21,1
         	MOVLW       	B'00001111'
         	ANDWF       	OZY22,0
         	CALL        	SDVIG
		MOVWF		OZY14
		MOVLW		B'11110000'
		ANDWF		OZY22,1
		SWAPF		OZY22,0
		CALL		SDVIG
		MOVWF		OZY22
		SWAPF		OZY22,1
		MOVF		OZY14,0
		IORWF		OZY22,1
         	RLF         	OZY11,1
         	RLF         	OZY12,1
         	RLF         	OZY21,1
         	RLF         	OZY22,1
         	DECFSZ      	OZY13,1
         	GOTO        	PROV
         	MOVF        	OZY21,0
         	ANDLW       	B'00001111'
         	MOVWF       	OZY31
         	SWAPF       	OZY21,0
         	ANDLW       	B'00001111'
         	MOVWF       	OZY32
         	MOVF        	OZY22,0
         	ANDLW       	B'00001111'
         	MOVWF       	OZY33
		SWAPF		OZY22,0
		ANDLW		B'00001111'
		MOVWF		OZY34
		BCF		PORTA,0
		MOVLW		B'10101000'
		CALL		ZAGR
		BSF		PORTA,0
		MOVLW		PB
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		FE
		CALL		ZAGR
		MOVLW		r
		CALL		ZAGR
		MOVLW		e
		CALL		ZAGR
		MOVLW		q
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		CALL		STRAZ
		CALL		ZAGR
		MOVF		OZY33,0
		CALL		CIFRA
		CALL		ZAGR
		MOVF		OZY32,0
		CALL		CIFRA
		CALL		ZAGR
		MOVF		OZY31,0
		CALL		CIFRA
		CALL		ZAGR
		MOVLW		M
		CALL		ZAGR
		MOVLW		H
		CALL		ZAGR
		MOVLW		ze
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		MOVLW		PB
		CALL		ZAGR
		RETURN

STRAZ		CLRW
		XORWF		OZY34,0
		BTFSS		STATUS,Z
		GOTO		STRA
		MOVLW		PB
         	RETURN

STRA		MOVF		OZY34,0
		CALL		CIFRA
		RETURN
		

PROG		CLRWDT
		MOVLW		B'11000010'
		MOVWF		OZY58
		MOVF		OZY67,0
		MOVWF		OZY57
		MOVF		OZY66,0
		MOVWF		OZY56
		MOVLW		B'11001110'
		MOVWF		OZY55
		MOVLW		B'00000000'
		MOVWF		OZY54
		MOVLW		D'5'
		MOVWF		OZY52
		BSF		PORTA,0		;DATA
		BSF		PORTA,2		;CLOK
		CALL		ZAD5
		BCF		PORTA,0
		CALL		ZAD5
		BCF		PORTA,2
		CALL		ZAD5
		BCF		STATUS,C
LOOP		CLRWDT
		MOVLW		D'8'
		MOVWF		OZY53
LOOP1		CLRWDT
		RLF		OZY54,1
		RLF		OZY55,1
		RLF		OZY56,1
		RLF		OZY57,1
		RLF		OZY58,1
		CALL		VETVL
AZA		CALL		ZAD5
		BSF		PORTA,2
		CALL		ZAD5
		BCF		PORTA,2
		DECFSZ		OZY53,1
		GOTO		LOOP1
		CALL		ZAD5
		BCF		PORTA,0
		CALL		ZAD5
		BSF		PORTA,2
		CALL		ZAD5
		BCF		PORTA,2
		DECFSZ		OZY52,1
		GOTO		LOOP
		CALL		ZAD5
		BCF		PORTA,0
		CLRWDT
		BSF		PORTA,2
		CALL		ZAD5
		BSF		PORTA,0
		RETURN
		
VETVL		BTFSS		STATUS,C
		GOTO		LOWE
		BSF		PORTA,0
		RETURN
LOWE		BCF		PORTA,0
		RETURN



PR_STR		BCF		OZY60,1
		BSF		STATUS,RP0
		MOVLW		B'10000111'
		MOVWF		PORTB
		BCF		STATUS,RP0
		BTFSS		PORTB,7
		BSF		OZY60,1
		BSF		STATUS,RP0
		MOVLW		B'00000111'
		MOVWF		PORTB
		BCF		STATUS,RP0
		RETURN
		



		END

